using System.ComponentModel.DataAnnotations;
using System.Reflection;
using Domain.Entities.Forum.Boards;
using Domain.Entities.Forum.ValueObject;
using SharedKernel.Extensions;
using Application.Abstractions.Messaging;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace Admin.Pages.Forum.Board.Meta;

public class NotifyModel(IMediator mediator) : PageModel
{
    public int BoardID { get; set; }
    public List<(int ID, string Name)> BoardList { get; set; } = [];
    public string? QueryString { get; set; }
    public List<SelectListItem> NotifyList { get; set; } = [];

    [BindProperty]
    public InputModel Input { get; set; } = new();

    public sealed class InputModel
    {
        public int ID { get; set; }
        public int BoardID { get; set; }
        public byte? PostWriteNotify { get; set; }
        public byte? CommentWriteNotify { get; set; }
        public byte? ReplyWriteNotify { get; set; }
    }

    public async Task OnGetAsync(int id, CancellationToken ct)
    {
        BoardID = id;
        QueryString = Request.QueryString.ToString();

        NotifyList = [..Enum.GetValues<BoardNotify>().Select(e => new SelectListItem
        {
            Value = ((byte)e).ToString(),
            Text = e.GetType().GetMember(e.ToString()).FirstOrDefault() ?.GetCustomAttribute<DisplayAttribute>()?.Name ?? e.ToString()
        })];

        var boards = await mediator.Send(new SearchBoards.Query(null, null, 1, 100), ct);
        BoardList = [..boards.List.Select(c => (c.ID, c.Name))];

        var meta = await mediator.Send(new GetBoardMeta.Query(id), ct);

        Input = new InputModel
        {
            ID = meta.ID,
            BoardID = meta.BoardID,
            PostWriteNotify = meta.Notify.PostWriteNotify,
            CommentWriteNotify = meta.Notify.CommentWriteNotify,
            ReplyWriteNotify = meta.Notify.ReplyWriteNotify
        };
    }

    public async Task<IActionResult> OnPostAsync(CancellationToken ct)
    {
        try
        {
            if (!ModelState.IsValid)
            {
                throw new Exception(ModelState.GetErrorMessages());
            }

            await mediator.Send(new UpdateBoardMeta.Command(
                Input.ID,
                Input.BoardID,
                null,
                null,
                null,
                null,
                null,
                null,
                new BoardMetaNotify
                {
                    PostWriteNotify = Input.PostWriteNotify,
                    CommentWriteNotify = Input.CommentWriteNotify,
                    ReplyWriteNotify = Input.ReplyWriteNotify
                },
                null,
                null
            ), ct);

            TempData["SuccessMessage"] = "알림 설정이 저장되었습니다.";
        }
        catch (Exception e)
        {
            TempData["ErrorMessages"] = e.Message;
        }

        return Redirect($"/Forum/Board/Meta/Notify/{Input.BoardID}{Request.QueryString}");
    }
}